module MySQLEncryption
  # Mimics MySQL's AES_ENCRYPT() and AES_DECRYPT() encryption functions
  $encryption_key ||= "hzjd88hqxejak31"

  def mysql_encrypt(s, key=$encryption_key)
    return nil if s.blank?
    do_encrypt(s, mysql_key(key))
  end
  
  def mysql_decrypt(s, key=$encryption_key)
    return nil if s.blank?
    do_decrypt(s, mysql_key(key))
  end
  
  protected

  def aes(m,k,t)
    (aes = OpenSSL::Cipher::AES128.new("ECB").send(m)).key = k
    aes.update(t) << aes.final
  end

  def do_encrypt(text, key)
    aes(:encrypt, key, text)
  end

  def do_decrypt(text, key)
    aes(:decrypt, key, text)
  end

  #
  # This method returns a key based on the specified key that is
  # 16 bytes in length. If the specified key is shorter than 16 bytes
  # it is zero-padded to 16 bytes. If the specified key is longer
  # 16 bytes, the bytes of the original key are folded back on itself
  # using the XOR operator. This ensures that all the bytes in the
  # original key are used, but the resulting key remains 16 bytes long.
  #
  # Sheesh.
  #
  def mysql_key(key)
    return nil if key.nil?
    final_key = "\0" * 16
    key.bytes.each_with_index do |b, i|
      buf = (final_key[i%16].bytes.first ^ b)
      final_key[i%16] = buf.chr
    end
    final_key
  end

end

=begin
Copyright (c) 2009 Felipe Coury
 
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:
 
The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.
 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
=end
